/**
 * Simple UI element to obtain queries
 */

package sbktech.jirc;

import java.awt.*;
import sbktech.tools.scm.*;

class QueryBox extends Frame
{
  TextField queries[];
  Button cancel, ok;
  Procedure proc;

  QueryBox(Cell l)
  {
    super("jirc Query");
    Panel p = new Panel();
    add("South", p);
    p.add(ok = new Button("  Ok  "));
    p.add(cancel = new Button("Cancel"));

    p = new Panel();
    GridBagLayout gb = new GridBagLayout();
    p.setLayout(gb);
    GridBagConstraints gc = new GridBagConstraints();
    gc.fill = gc.HORIZONTAL;
    gc.weightx = 1.0;

    add("Center", p);
                                // Add the queries one by one.
    Panel q;
    int num = 0;
                                // 2 pass to avoid vector
    Cell t = l;
    while (t != null) { num++; t = t.cdr; }
    queries = new TextField[num];
    num=0;
    while (l != null)
      {
        String s = ((Selfrep)(l.car)).val;
        q = new Panel();
        q.setLayout(new BorderLayout());
        q.add("West", new Label(s));
        q.add("Center", queries[num++] = new TextField());
        gc.gridy = num;
        p.add(q);
        gb.setConstraints(q, gc);
        l = l.cdr;
      }
    resize(500, 300);
    show();
  }

  public boolean action(Event e, Object arg)
  {
    if ((e.target == ok) &&
        (proc != null))
      {
        Cell list = null;
        Cell tail = null;

        for (int i=0; i<queries.length; i++)
          {
            Cell t = new Cell(new Selfrep(queries[i].getText()), null);
            if (tail == null)
              {
                tail = t;
                list = t;
              }
            else
              {
                tail.cdr = t;
                tail = t;
              }
          }
        try
          {
            proc.apply(list, driver.global);
          }
        catch (Exception exc) {}
        dispose();
        return true;
      }
    else if (e.target == cancel)
      {
        dispose();
        return true;
      }
    return false;
  }

  void setHook(Procedure proc)
  {
    this.proc = proc;
  }
}
