                                // Generate glue code

import java.io.*;
import java.util.*;

class typeinfo
{
  String scm_name;
  String java_name;
  String java_inp_type[];

  typeinfo(String sname, String jname, String jit[])
  {
    scm_name = sname;
    java_name = jname;
    java_inp_type = jit;
  }

  void write(PrintStream out)
  {
    int mode;

    out.println("//Autogenerated by typeinfo on " + new Date());

    out.println("class scm" + java_name + " extends Procedure implements Obj");
    out.println("{");
    out.println("  public Obj apply(Cell args, Env f)\n  throws Exception\n  {");
    out.println("    Cell t = args;");
    out.println("    Obj  tmp;");
    for (int i=0; i<java_inp_type.length; i++)
      {
        out.println("    if (t == null) { throw new SchemeError(\""
                    + scm_name + " expects "
                    + java_inp_type.length +
                    " arguments\"); }");
        out.println("    tmp = (t.car!=null)?t.car.eval(f):null; t = t.cdr;");

        if (java_inp_type[i].equals("String")) { mode = 0; }
        else if ((java_inp_type[i].equals("short")) ||
                 (java_inp_type[i].equals("int")) ||
                 (java_inp_type[i].equals("float")) ||
                 (java_inp_type[i].equals("double")) ||
                 (java_inp_type[i].equals("long"))) { mode = 1; }
        else if ((java_inp_type[i].equals("Procedure")) ||
                 (java_inp_type[i].equals("Cell"))) { mode = 2; }
        else if ((java_inp_type[i].equals("boolean")))
          { mode  = 3; }
        else { mode = 4; }

        switch(mode)
          {
          case 0:               // String
            out.println
              ("    if ((tmp != null) && !(tmp instanceof Selfrep))" +
               " { throw new SchemeError(\"" +
               scm_name + " expects a String for arg #" + (i+1) +
               "\"); }");
            out.println
              ("    String arg" + i + " = (tmp!=null)?((Selfrep)tmp).val:null;");
            break;
          case 1:               // number
            out.println
              ("    if (!(tmp instanceof Selfrep))" +
               " { throw new SchemeError(\"" +
               scm_name + " expects a number for arg #" + (i+1) +
               "\"); }");
            out.println
              ("    "+java_inp_type[i]+" arg" + i +
               " = (" + java_inp_type[i] + ")(((Selfrep)tmp).num);");
            break;
                                // Procedure
          case 2:
            out.println
              ("    if (!(tmp instanceof "+java_inp_type[i]+"))" +
               " { throw new SchemeError(\"" +
               scm_name + " expects a "+java_inp_type[i]+" for arg #" + (i+1) +
               "\"); }");
            out.println
              ("    "+java_inp_type[i]+" arg" + i +
               " = (" + java_inp_type[i] + ")((("+java_inp_type[i]+")tmp));");
            break;

          case 3:
                                // boolean
            out.println
              ("    boolean arg" + i + " = (tmp != null);");
            break;
            
          default:              // primnode
            out.println
              ("    if ((tmp != null) && !(tmp instanceof primnode))" +
               " { throw new SchemeError(\"" +
               scm_name + " expects a " + java_inp_type[i] +
               " for arg #" + (i+1) + "\"); }");
            out.println
              ("    if ((tmp != null) && !((((primnode)tmp).val) instanceof " + 
               java_inp_type[i] + ")) { throw new SchemeError(\"" +
               scm_name + " expects a " + java_inp_type[i] +
               " for arg #" + (i+1) + "\"); }");
            out.println
              ("    "+java_inp_type[i]+" arg" + i +
               " = (tmp != null)?(" + java_inp_type[i] + ")(((primnode)tmp).val):null;");
            break;
          }
      }

                                // Now create the new object
    out.print("    return new primnode(new " +
              java_name + "(");

    if (java_inp_type.length != 0)  out.print("arg0");

    for (int i=1; i<java_inp_type.length; i++)
      { out.print(", arg" + i); }
    out.println("));\n  }");
    out.println("  public String toString()");
    out.println("  { return (\"<#" + scm_name + "#>\"); }");
    out.println("}");
  }
}

class procinfo
                                // Create simple procedures
                                // automatically
{
  String java_name;
  String scm_name;
  String java_inp_type[];
  String java_ret_type;

  procinfo(String sname, String jname, String jit[], String jrt)
  {
    java_name = jname;
    scm_name = sname;
    java_inp_type = jit;
    java_ret_type = jrt;
  }

  void write_depending_on_type
  (PrintStream out, String typename, String varname, String argname)
  {
    int mode;

    if (typename.equals("String")) { mode = 0; }
    else if ((typename.equals("short")) ||
             (typename.equals("int")) ||
             (typename.equals("float")) ||
             (typename.equals("double")) ||
             (typename.equals("long"))) { mode = 1; }
    else if ((typename.equals("Procedure")) ||
             (typename.equals("Cell"))) { mode = 2; }
    else if (typename.equals("boolean"))
             { mode = 3; }
    else { mode = 4; }

    switch(mode)
      {
      case 0:                   // String
        out.println
          ("    if (("+varname+" != null) && !("+varname+" instanceof Selfrep))" +
           " { throw new SchemeError(\"" +
           scm_name + " expects a String for " + argname +
           "\"); }");
        out.println
          ("    String "+argname+" = ("+varname+"!=null)?((Selfrep)"+varname+").val:null;");
        break;
      case 1:               // number
        out.println
          ("    if (!("+varname+" instanceof Selfrep))" +
           " { throw new SchemeError(\"" +
           scm_name + " expects a number for " + argname +
           "\"); }");
        out.println
          ("    "+typename+" " + argname +
           " = (" + typename + ")(((Selfrep)"+varname+").num);");
        break;
      case 2:
        out.println
          ("    if (!("+varname+" instanceof "+typename+"))" +
           " { throw new SchemeError(\"" +
           scm_name + " expects a "+typename+" for " + argname + 
           "\"); }");
        out.println
          ("    "+typename+"  " + argname +
           " = (" + typename + ")((("+typename+")"+varname+"));");
        break;

      case 3:
        // boolean
        out.println
          ("   boolean "+argname+" = ("+varname+" != null);");
        break;

      default:              // primnode
        out.println
          ("    if (("+varname+" != null) && !("+varname+" instanceof primnode))" +
           " { throw new SchemeError(\"" +
           scm_name + " expects a " + typename +
           " for " + argname +"\"); }");
        out.println
          ("    if (("+varname+" != null) && !((((primnode)"+varname+").val) instanceof " + 
           typename + ")) { throw new SchemeError(\"" +
           scm_name + " expects a " + typename +
           " for " + argname + "\"); }");
        out.println
          ("    "+typename+" " + argname +
           " = ("+varname+" != null)?(" + typename + ")(((primnode)"+varname+").val):null;");
        break;
      }
  }

  void write(PrintStream out)
  {
    int mode;

    out.println("//Autogenerated by procinfo on " + new Date());
    out.println
      ("class scm" + java_name + " extends Procedure implements Obj\n{");
    out.println
      ("  public Obj apply(Cell args, Env f)\n  throws Exception\n  {\n");
    out.println
      ("    Cell t = args;");
    out.println
      ("    Obj tmp;");
    for (int i=0; i<java_inp_type.length; i++)
      {
        out.println
          ("    if (t == null) { throw new SchemeError(\""
           + scm_name + " expects "
           + java_inp_type.length +
           " arguments\"); }");
        out.println
          ("    tmp = (t.car!=null)?t.car.eval(f):null; t = t.cdr;");

        write_depending_on_type
          (out, java_inp_type[i],   "tmp", "arg" + i);
      }

                                // now call the method
    if (java_ret_type != null)
      {
        out.print("  " + java_ret_type + " ret_val =");
      }

    if (java_inp_type.length == 1)
      {
        out.print("    arg0." + java_name + "(");
      }
    else
      {
        out.print("    arg0." + java_name + "(arg1");
        for (int i=2; i<java_inp_type.length; i++)
          { out.print(", arg" + i); }
      }
    out.println(");");
    if (java_ret_type != null)
      {
        if ((java_ret_type.equals("String")) ||
            (java_ret_type.equals("short")) ||
            (java_ret_type.equals("int")) ||
            (java_ret_type.equals("float")) ||
            (java_ret_type.equals("double")) ||
            (java_ret_type.equals("long")))
          {
            out.println("return new Selfrep(ret_val);");
          }
        else
          if ((java_ret_type.equals("boolean")))
            {
              out.println(" return ret_val?(new Selfrep(1)):null;");
            }
        else
          { out.println(" return new primnode(ret_val);"); }
      }
    else
      {  out.println(" return null;"); }
    out.println(" }");
    out.println("  public String toString()");
    out.println("  { return (\"<#" + scm_name + "#>\"); }");
    out.println("}");
  }
}

class autogen
{
  
  static String procs[][] =
    {
                                // Do things with the IRC env
      {"ircEnv", "String", "int", "String", "String", "String", "String"},
          {"irc-env-set!", "populate", null},
      {"ircEnv", "String"}, {"irc-send", "send", null},
      {"ircEnv"}, {"irc-connect", "connect", null},
      {"ircEnv", "String", "Procedure"},
          {"irc-set-msg-hook!", "setMsgHook", null},
      {"ircEnv", "Procedure"},
          {"irc-set-default-msg-hook!", "setDefaultMsgHook", null},

                                // Display areas
      {"SimpleFrame"}, {"frame-show", "show", null},
      {"SimpleFrame", "String"}, {"frame-append-text", "appendDisplay", null},
      {"SimpleFrame", "Procedure"},
          {"frame-set-user-hook!", "setUserHook", null},
      {"SimpleFrame"}, {"frame-get-current-target", "getTarget", "String"},
      {"SimpleFrame", "Menu"}, {"frame-add-menu", "addMenu", null},
      {"SimpleFrame", "Button"}, {"frame-add-command", "addCommand", null},
      {"SimpleFrame", "MenuItem", "Procedure"},
          {"frame-set-menu-item-hook!", "setMenuItemHook", null},
      {"SimpleFrame", "Button", "Procedure"},
          {"frame-set-command-hook!",  "setCommandHook", null},
      {"SimpleFrame"}, {"frame-dispose", "dispose", null},

                                // QueryBox
      {"QueryBox", "Procedure"}, {"query-box-set-hook!", "setHook", null},

                                // Menu procedures
      {"Menu", "MenuItem"}, {"menu-add-item", "add", null},
                                // Showing documents
      {"driver", "String", "String"}, {"context-show-url", "swooshURL", null},

                                // Message manipulation
      {"message"}, {"irc-msg-prefix", "getPrefix", "String"},
      {"message"}, {"irc-msg-ctcp-tag", "getCtcpTag", "String"},
      {"message"}, {"irc-msg-prefix-name", "getPrefixName", "String"},
      {"message"}, {"irc-msg-prefix-host", "getPrefixHost", "String"},
      {"message"}, {"irc-msg-command", "getCommand", "String"},
      {"message"}, {"irc-msg-trailer", "getTrailer", "String"},
      {"message"}, {"irc-msg-comma-middle", "getCommaMiddle", "String"},

                                // Plug into default string operators
      {"String", "String", "int"},
        {"string-starts-with?", "startsWith", "boolean"}

    };

  static String types[][] =
    {
      {}, {"make-irc-env", "ircEnv"},
      {"String"}, {"make-frame", "SimpleFrame"},
      {"String"}, {"make-menu", "Menu"},
      {"String"}, {"make-menu-item", "MenuItem"},
      {"String"}, {"make-command", "Button"},
      {"String"}, {"make-interpreter-frame", "InterpreterFrame"},
      {"Cell"}, {"make-query-box", "QueryBox"},
      
    };

  public static void main(String argv[])
    throws IOException
  {

    PrintStream initer =
      new PrintStream(new FileOutputStream("AutoInit.java"));
    initer.println("package sbktech.jirc;\n\nimport sbktech.tools.scm.*;");
    initer.println("import java.awt.*;");
    initer.println("class AutoInit\n{\n  static void fillit(Env e)\n  {");

                                // Generate types in the system.
    PrintStream doit = new PrintStream(new FileOutputStream("AutoTypes.java"));
    doit.println("package sbktech.jirc;\n\nimport sbktech.tools.scm.*;");
    doit.println("import java.awt.*;");

    for (int x = 0; x<types.length; x += 2)
      {
        typeinfo tp = new typeinfo(types[x+1][0], types[x+1][1], types[x]);
        tp.write(doit);
        initer.println("e.definevar(Symbol.intern(\"" +
                       types[x+1][0] + "\"), new scm" +
                       types[x+1][1] + "());");
      }

                                // Add some simple procedures
    doit = new PrintStream(new FileOutputStream("AutoProcs.java"));
    doit.println("package sbktech.jirc;\n\nimport sbktech.tools.scm.*;");
    doit.println("import java.awt.*;");
    for (int x = 0; x<procs.length; x += 2)
      {
        procinfo p =
          new procinfo(procs[x+1][0], procs[x+1][1], procs[x], procs[x+1][2]);
        initer.println("e.definevar(Symbol.intern(\"" +
                       procs[x+1][0] + "\"), new scm" +
                       procs[x+1][1] + "());");
        p.write(doit);
      }

    initer.println("  }\n}");
  }
}
