/**
 * Parse the message portion of a line.
 */

package sbktech.jirc;

import java.util.*;

class message
{
  String prefix;
  String command;
  Vector middle;
  String trailer;
  String ctcp_tag_rest;


  String getPrefix()
  { return prefix; }
  String getPrefixHost()
  {
    int idx = prefix.indexOf('!');
    if (idx >= 0)
      { return prefix.substring(idx+1, prefix.length()); }
    else
      { return prefix; }
  }
  String getPrefixName()
  {
    int idx = prefix.indexOf('!');
    if (idx >= 0)
      { return prefix.substring(0, idx); }
    else
      { return prefix; }
  }

  String getCommand()
  { return command; }
  String getTrailer()
  { return trailer; }
  String getCtcpTag()
  { return ctcp_tag_rest; }

  String getCommaMiddle()
  {
    String ret = "";
    if (middle != null)
      {
        Enumeration e = middle.elements();
        ret = (String)(e.nextElement());
        while (e.hasMoreElements())
          { ret += ", " + (String)(e.nextElement()); }
      }
    return ret;
  }

  message(String line)
  {
                                // This is a cr/lf terminated line.
    int index = 0;
    int len = line.length();
    char cur_char;
    while ((index < len) &&
           ((cur_char = line.charAt(index++)) != '\r') &&
            (cur_char != '\n'))
      {
                                // Ok, we are strictly inside the
                                // legit string now.

                                // look for a prefix
        if (cur_char == ':')
          {
            while ((index < len) &&
                   ((cur_char = line.charAt(index++)) != '\r') &&
                   (cur_char != '\n') &&
                   (cur_char != ' '))
              ;

            prefix = line.substring(1, index);

                                // skip ws
            while ((index < len) &&
                   ((cur_char = line.charAt(index++)) != '\r') &&
                   (cur_char != '\n') &&
                   (cur_char == ' '))
              ;
          }

        if ((cur_char == '\r') ||
            (cur_char == '\n'))
          return;

                                // now parse command portion.

        int mark = index-1;
        while ((index < len) &&
               ((cur_char = line.charAt(index++)) != '\r') &&
               (cur_char != '\n') &&
               (cur_char != ' '))
          ;

        command = line.substring(mark, index-1);
        command = command.toUpperCase();

                                // skip ws
        while ((index < len) &&
               ((cur_char = line.charAt(index++)) != '\r') &&
               (cur_char != '\n') &&
               (cur_char == ' '))
          ;

        if ((cur_char == '\r') ||
            (cur_char == '\n'))
          return;

                                // look for any middle strings
        if (cur_char != ':')
          {
            middle = new Vector();
            while ((index < len) &&
                   (cur_char != ':') &&
                   (cur_char != '\r') &&
                   (cur_char != '\n'))
              {
                mark = index-1;
                while ((index < len) &&
                       ((cur_char = line.charAt(index++)) != '\r') &&
                       (cur_char != '\n') &&
                       (cur_char != ' '))
                  ;
                middle.addElement(line.substring(mark, index));
                                // skip ws
                while ((index < len) &&
                       ((cur_char = line.charAt(index++)) != '\r') &&
                       (cur_char != '\n') &&
                       (cur_char == ' '))
                  ;
              }
          }

        if ((cur_char == '\r') ||
            (cur_char == '\n'))
          return;

                                // now for the trailer
        mark = index;
        while ((index < len) &&
               ((cur_char = line.charAt(index++)) != '\r') &&
               (cur_char != '\n'))
          ;

        trailer = line.substring(mark, index);
                                // On PRIVMSG/NOTICE, start
                                // any extra processing
        if (command.equals("PRIVMSG") ||
            command.equals("NOTICE"))
                                // Simple ctcp msgs.
                                // Does *not* parse completely
                                // FIXMEEE
          {
            maybeCtcp();
          }
        return;
      }
  }
                                // Check for simple ctcp messages
  void maybeCtcp()
  {
    if (trailer.charAt(0) == '\001')
      {
                                // Pretend this is a complete ctcp
                                // message, which isn't true but
                                // covers most of the common cases.
                                // bad case of programmer laziness.
        int idx = trailer.indexOf(' ');
        String c;
        if (idx == -1)
          {
            c = trailer.substring(1, trailer.length()-1);
          }
        else
          {
            c = trailer.substring(1, idx);
            ctcp_tag_rest = trailer.substring(idx, trailer.length()-1);
          }
        trailer = null;
        command = command + "/"+c;
      }
  }

  public String toString()
  {
    String ret =
      "Command: " + command +
      "\nprefix : " + prefix +
      "\ntrailer: " + trailer +
      "\nmiddle : " + middle;
    return ret;
  }
}
