package sbktech.tools.scm;

import java.io.*;
import java.util.*;
import sun.tools.java.RuntimeConstants;

public class parser
{
  static Hashtable syms;
  StreamTokenizer inp;
  Env global;
  public parser(StreamTokenizer inp, Env global)
  {
    this.inp = inp;
    this.global = global;

    inp.resetSyntax();
    inp.wordChars('a', 'z');
    inp.wordChars('A', 'Z');
    inp.wordChars('!', '!');
    inp.wordChars('?', '?');
    inp.wordChars('_', '_');
    inp.wordChars(128 + 32, 255);
    inp.whitespaceChars(0, ' ');
    inp.quoteChar('"');
    inp.commentChar(';');
    inp.parseNumbers();
    inp.eolIsSignificant(false);

                                // Add standard functions
    global.definevar(Symbol.intern("define"), new Define());
    global.definevar(Symbol.intern("set!"), new Setvar());
    global.definevar(Symbol.intern("lambda"), new Lambda());
    global.definevar(Symbol.intern("quote"), new Quote());
    global.definevar(Symbol.intern("car"), new Car());
    global.definevar(Symbol.intern("cdr"), new Cdr());
    global.definevar(Symbol.intern("cons"), new Cons());
    global.definevar(Symbol.intern("cond"), new Cond());
    global.definevar(Symbol.intern("num?"), new NumP());
    global.definevar(Symbol.intern("string?"), new StringP());
    global.definevar(Symbol.intern("progn"), new Progn());
    global.definevar(Symbol.intern("mapcar"), new Mapcar());
    global.definevar(Symbol.intern("concat"), new Concat());
    global.definevar(Symbol.intern("+"), new Plus());
    global.definevar(Symbol.intern("-"), new Minus());
    global.definevar(Symbol.intern("*"), new Mult());
    global.definevar(Symbol.intern("/"), new Div());
    global.definevar(Symbol.intern("|"), new Or());
    global.definevar(Symbol.intern("<"), new LessP());
    global.definevar(Symbol.intern(">"), new MoreP());
    global.definevar(Symbol.intern("eq?"), new EqP());
  }

  public Obj eval()
    throws Exception
  {
                                // enter one repl loop
    inp.nextToken();
    Obj c = readinp(inp);
    if (c != null)  { c = c.eval(global); }
        // uncomment this if you want to
        // see the results of the eval
        //        if (c == null) System.out.println("nil");
        //        else System.out.println(c.toString());
    return c;
  }

  static Obj readinp(StreamTokenizer inp)
    throws IOException
  {
    switch (inp.ttype)
      {
      case '(':
        return readparen(inp);
      case ')':
        throw new SchemeError("Unexpected close paren");
      default:
        return readtok(inp);
      }
  }

  static Cell readparen(StreamTokenizer inp)
    throws IOException
  {
    inp.nextToken();
    if (inp.ttype == ')') return (null);

    return(new Cell(readinp(inp), readparen(inp)));
  }

  static Obj readtok(StreamTokenizer inp)
  {
    Obj ret;
    switch (inp.ttype)
      {
      case inp.TT_NUMBER:
        ret = new Selfrep((int)inp.nval); break;
      case '"':
        ret = new Selfrep(inp.sval); break;
      case inp.TT_WORD:
        ret = Symbol.intern(inp.sval); break;
      case '+':
      case '-':
      case '*':
      case '/':
      case '|':
      case '<':
      case '>':
        ret =  Symbol.intern(String.valueOf((char)(inp.ttype)));
        break;
      case inp.TT_EOF:
        return null;
      default:
        throw new SchemeError("Unexpected parse error");
      }
    return ret;
  }
}
